package me.hammerle.code;

import java.awt.Graphics;
import java.util.TreeMap;
import javax.swing.JPanel;
import me.hammerle.graphics.GraphicObject;

public class GraphicEngine extends JPanel
{
    private final TreeMap<Integer, GraphicObject> objects;
    private GraphicObject buffer;
    
    public GraphicEngine()
    {
        this.objects = new TreeMap<>();
    }
    
    public GraphicObject getBuffer()
    {
        return buffer;
    }
    
    public GraphicObject loadGraphicObjectIntoBuffer(int id)
    {
        buffer = objects.get(id);
        return buffer;
    }
    
    public void removeGraphicObject(int id)
    {
        objects.remove(id);
    }
    
    public void addGraphicObject(int id, GraphicObject go)
    {
        objects.put(id, go);
    }
    
    @Override
    public void paint(Graphics g) 
    {
        super.paint(g);
        objects.forEach((i, go) -> 
        {
            g.setColor(go.getColor());
            go.paint(g);
        });
    }   
}
