package me.hammerle.code;

import java.awt.Color;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.event.MouseInputAdapter;

public class ScriptEngine extends JFrame
{
    public final GraphicEngine graphics;
    
    public ScriptEngine()
    {
        graphics = new GraphicEngine();
        graphics.setBackground(Color.black);
        super.add(graphics);
        super.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        super.addWindowListener(new WindowAdapter() 
        {
            @Override
            public void windowClosing(WindowEvent evt) 
            {
                windowClosingEvent(evt);
            }
        });
        
        super.addKeyListener(new KeyAdapter()
        {
            @Override
            public void keyPressed(KeyEvent e) 
            {
                keyEvent(e, "pressed");
            } 
            @Override
            public void keyTyped(KeyEvent e) 
            {
                keyEvent(e, "typed");
            }
            @Override
            public void keyReleased(KeyEvent e) 
            {
                keyEvent(e, "released");
            }
        });
        
        graphics.addMouseListener(new MouseInputAdapter() 
        {
            @Override
            public void mousePressed(MouseEvent e) 
            {
                mouseEvent(e, "pressed");
            }          
        });
    }
    
    private void windowClosingEvent(WindowEvent e)
    {
        /*ScriptData sd = SnuviScript.scriptController.getActiveScript();
        if(sd.isEventLoaded("window-closing"))
        {
            sd.setVar("event", "window-closing");
            sd.nextCodeLine();
            CodeParser.continueCode(sd, null); 
        }*/
    }
    
    private void keyEvent(KeyEvent e, String name)
    {
        /*ScriptData sd = SnuviScript.scriptController.getActiveScript();
        if(sd.isEventLoaded("key-" + name))
        {
            sd.setVar("event", "key-" + name);
            sd.setVar("keycode", e.getKeyCode());
            sd.setVar("keychar", e.getKeyChar());
            sd.nextCodeLine();
            CodeParser.continueCode(sd, null); 
        }*/
    }
    
    private void mouseEvent(MouseEvent e, String name)
    {
        /*ScriptData sd = SnuviScript.scriptController.getActiveScript();
        if(sd.isEventLoaded("mouse-" + name))
        {
            sd.setVar("event", "mouse-" + name);
            sd.setVar("button", e.getButton());
            sd.setVar("count", e.getClickCount());
            sd.setVar("x", e.getX());
            sd.setVar("y", e.getY());
            sd.nextCodeLine();
            CodeParser.continueCode(sd, null); 
        }*/
    }
}
