package me.hammerle.code;

import java.awt.Color;
import java.util.Random;
import me.hammerle.exceptions.IllegalColorException;

public class ScriptUtils
{
    public static Color getColor(Object o) throws IllegalColorException
    {
        try
        {
            String[] parts = o.toString().split(":");
            return new Color(Integer.parseInt(parts[0]), Integer.parseInt(parts[1]), Integer.parseInt(parts[2]));
        }
        catch(NumberFormatException | ArrayIndexOutOfBoundsException ex)
        {
            throw new IllegalColorException(o.toString());
        }
    }
    
    public static void printError(Object message)
    {
        System.out.println("Fehler: " + message);
        System.exit(0);
    }
    
    public static void printDebug(Object message)
    {
        System.out.println(message);
    }
    
    public static void printDebugList(Object message)
    {
        System.out.println(" - " + message);
    }
    
    public static int randomInt(int min, int max)
    {
        Random rand = new Random();
        int randomNum = rand.nextInt((max - min) + 1) + min;
        return randomNum;
    }
    
    
    public static Object getNumber(String s)
    {
        double d = Double.parseDouble(s);
        if((int) d == d)
        {
            return (int) d;
        }
        return d;
    }
    
    public static int getInteger(Object o)
    {
        if(o instanceof Double)
        {
            return (int) (double) o;
        }
        return (int) o;
    }
    
    public static double getDouble(Object o)
    {
        if(o instanceof Integer)
        {
            return (double) (int) o;
        }
        return (double) o;
    }
}
