package me.hammerle.graphics;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import me.hammerle.snuviscript.SnuviScript;

public class Image extends Line implements StartPoint
{
    private int x;
    private int y;
    private BufferedImage image;
    
    public Image(BufferedImage image, int x, int y, int x1, int y1, int x2, int y2)
    {
        super(null, x1, y1, x2, y2);
        this.image = image;
        this.x = x;
        this.y = y;
    }
    
    public Image(BufferedImage image, int x, int y)
    {
        this(image, x, y, 0, 0, image.getWidth(), image.getHeight());
    }
    
    @Override
    public void setX(int x)
    {
        this.x = x;
    }
    
    @Override
    public void setY(int y)
    {
        this.y = y;
    }
    
    @Override
    public int getX()
    {
        return x;
    }
    
    @Override
    public int getY()
    {
        return y;
    }
    
    public void setImage(BufferedImage image)
    {
        this.image = image;
    }
    
    @Override
    public void paint(Graphics g) 
    {
        g.drawImage(image.getSubimage(x1, y1, x2 - x1, y2 - y1), x, y, SnuviScript.screen);
    }
}
