package me.hammerle.graphics;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

public class Text extends GraphicObject implements StartPoint
{
    private String text;
    private Font font;
    private int x;
    private int y;
    
    public Text(Color c, int x, int y, String text, Font font) 
    {
        super(c);
        this.x = x;
        this.y = y;
        this.text = text;
        this.font = font;
    }
    
    @Override
    public void setX(int x)
    {
        this.x = x;
    }
    
    @Override
    public void setY(int y)
    {
        this.y = y;
    }
    
    @Override
    public int getX()
    {
        return x;
    }
    
    @Override
    public int getY()
    {
        return y;
    }
    
    public void setText(String text)
    {
        this.text = text;
    }
    
    public void setfont(Font font)
    {
        this.font = font;
    }
    
    public String getText()
    {
        return text;
    }
    
    public Font getfont()
    {
        return font;
    }

    @Override
    public void paint(Graphics g) 
    {
        g.setFont(font);
        g.drawString(text, x, y);
    }  
}
